CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

obj
  pcm : "PCM_021.spin"

var
  long  ors
  long  ors2

pub main

pcm.Start(31, 100)     'pin 31, 1 second has 100 divisions


' Demo of OR Mask
ors := 0
repeat 64
  pcm.PlayNote(1, pcm#tE3, 0, 0, 0, ors, 10, 2)
  waitcnt(clkfreq / 40 + cnt) 
  ors++
ors := 0
repeat 64
  pcm.PlayNote(1, pcm#tB2, 0, 0, 0, ors, 10, 2)
  waitcnt(clkfreq / 40 + cnt) 
  ors++

ors := 0
repeat 64
  pcm.PlayNote(1, pcm#tE3, 0, 0, 0, ors, 10, 1)
  waitcnt(clkfreq / 40 + cnt) 
  ors++
ors := 0
repeat 64
  pcm.PlayNote(1, pcm#tB2, 0, 0, 0, ors, 10, 1)
  waitcnt(clkfreq / 40 + cnt) 
  ors++



'Demo of garbles
ors := 3
repeat 10
  pcm.PlayNote(1, pcm#tE3, 0, 0, ors, 0, 10, 3)
  waitcnt(clkfreq / 7 + cnt) 
  ors++
ors := 3
repeat 10
  pcm.PlayNote(1, pcm#tB2, 0, 0, ors, 0, 10, 3)
  waitcnt(clkfreq / 7 + cnt) 
  ors++


'demo of multiple channels / chords  
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tC5, 0, 0, 0, 0, 100, 2)
pcm.PlayNote(2, pcm#tE5, 0, 0, 0, 0, 100, 2)
pcm.PlayNote(3, pcm#tG5, 0, 0, 0, 0, 100, 2)
waitcnt(clkfreq + cnt)  
pcm.PlayNote(1, pcm#tC5, 0, 0, 0, 0, 100, 2)
pcm.PlayNote(2, pcm#tE5, 0, 0, 0, 0, 100, 2)
pcm.PlayNote(3, pcm#tA5, 0, 0, 0, 0, 100, 2)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tC5, 2, 0, 0, 0, 100, 1)
pcm.PlayNote(2, pcm#tE5, 0, 0, 0, 0, 100, 2)
pcm.PlayNote(3, pcm#tA5, 0, 0, 0, 0, 100, 2)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tC5, 2, 0, 0, 0, 100, 2)
pcm.PlayNote(2, pcm#tE5, 2, 0, 0, 0, 100, 2)
pcm.PlayNote(3, pcm#tA5, 2, 0, 0, 0, 100, 2)
pcm.PlayNote(4, pcm#C3, 0, 0, 0, 0, 100, 2)

'just for fun
  waitcnt(clkfreq * 2 + cnt)
repeat 3                 
  ors := pcm#C3                              
  ors2:= pcm#C2                              
  repeat 10                                  
    pcm.PlayNote(1, ors, 0, 0, 0, 0, 20, 2)  
    pcm.PlayNote(2, ors2, 2, 26, 0, 0, 20, 2)
    waitcnt(clkfreq / 30 + cnt)              
    ors++                                    
    ors2++                                   
repeat 3                                   
  waitcnt(clkfreq / 60 + cnt)                   
  ors := pcm#F3                                
  ors2:= pcm#F2                                
  repeat 10                                    
    pcm.PlayNote(1, ors, 0, 0, 0, 0, 20, 2)    
    pcm.PlayNote(2, ors2, 2, 29, 0, 0, 20, 2)  
    waitcnt(clkfreq / 30 + cnt)                
    ors++                                      
    ors2++                                     
                                               